SystemOrganization addCategory: #'IdealTrie-SP-Tests'!

TestCase subclass: #BitOpsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IdealTrie-SP-Tests'!

!BitOpsTest methodsFor: 'bit selection tests' stamp: 'AndrewBlack 5/31/2012 11:52'!
testBitSelectSK3
	| sk3 |
	sk3 := 16r33333333.
	self assert: (sk3 bitsFrom: 2 to: 1) = 3.
	self assert: (sk3 bitsFrom: 4 to: 1) = 16r3.
	self assert: (sk3 bitsFrom: 8 to: 1) = 16r33.
	self assert: (sk3 bitsFrom: 12 to: 1) = 16r333.
	self assert: (sk3 bitsFrom: 16 to: 1) = 16r3333.
	self assert: (sk3 bitsFrom: 2 to: 2) = 1.
	self assert: (sk3 bitsFrom: 4 to: 2) = 16r1.
	self assert: (sk3 bitsFrom: 5 to: 2) = 16r9.
	self assert: (sk3 bitsFrom: 6 to: 2) = 16r19.
	self assert: (sk3 bitsFrom: 7 to: 2) = 16r19.
	self assert: (sk3 bitsFrom: 8 to: 2) = 16r19.
	self assert: (sk3 bitsFrom: 9 to: 2) = 16r99.
	self assert: (sk3 bitsFrom: 8 to: 5) = 16r3.
	self assert: (sk3 bitsFrom: 12 to: 9) = 16r3.
	self assert: (sk3 bitsFrom: 16 to: 9) = 16r33.
	! !

!BitOpsTest methodsFor: 'single pattern tests' stamp: 'AndrewBlack 5/31/2012 10:35'!
testCountBits0
	self assert: 0 numberOfOneBits = 0! !

!BitOpsTest methodsFor: 'single pattern tests' stamp: 'AndrewBlack 5/31/2012 10:35'!
testCountBits1
	self assert: 1 numberOfOneBits = 1! !

!BitOpsTest methodsFor: 'single pattern tests' stamp: 'AndrewBlack 5/31/2012 10:35'!
testCountBits2
	self assert: 2 numberOfOneBits = 1! !

!BitOpsTest methodsFor: 'single pattern tests' stamp: 'AndrewBlack 5/31/2012 10:36'!
testCountBits3
	self assert: 3 numberOfOneBits = 2! !

!BitOpsTest methodsFor: 'single pattern tests' stamp: 'AndrewBlack 5/31/2012 10:39'!
testCountBits4
	self assert: 4 numberOfOneBits = 1! !

!BitOpsTest methodsFor: 'single pattern tests' stamp: 'AndrewBlack 5/31/2012 10:39'!
testCountBits5
	self assert: 5 numberOfOneBits = 2! !

!BitOpsTest methodsFor: 'single pattern tests' stamp: 'AndrewBlack 5/31/2012 10:36'!
testCountBits6
	self assert: 6 numberOfOneBits = 2! !

!BitOpsTest methodsFor: 'single pattern tests' stamp: 'AndrewBlack 5/31/2012 10:36'!
testCountBits7
	self assert: 7 numberOfOneBits = 3! !

!BitOpsTest methodsFor: 'single pattern tests' stamp: 'AndrewBlack 5/31/2012 10:37'!
testCountBits8
	self assert: 8 numberOfOneBits = 1! !

!BitOpsTest methodsFor: 'single pattern tests' stamp: 'AndrewBlack 5/31/2012 10:48'!
testCountBitsNeg1
	self assert: ((2 raisedToInteger: 30) - 1) numberOfOneBits = 30! !

!BitOpsTest methodsFor: 'single pattern tests' stamp: 'AndrewBlack 5/31/2012 10:39'!
testCountBitsTwo20
	self assert: ((2 raisedToInteger: 20) - 1) numberOfOneBits = 20! !

!BitOpsTest methodsFor: 'multiple value tests' stamp: 'AndrewBlack 5/31/2012 11:26'!
testCountFourBits
	| p1 |
	p1 := 2r1111.
	0 to: 26 do: [ :n | self assert: ( p1 bitShift: n ) numberOfOneBits = 4]! !

!BitOpsTest methodsFor: 'multiple value tests' stamp: 'AndrewBlack 5/31/2012 11:27'!
testCountOneBits
	| p1 |
	p1 := 2r0001.
	0 to: 29 do: [ :n | self assert: ( p1 bitShift: n ) numberOfOneBits = 1]! !

!BitOpsTest methodsFor: 'multiple value tests' stamp: 'AndrewBlack 5/31/2012 11:27'!
testCountPowersOfTwo
	0 to: 29 do: [ :n | 
		self assert: (2 raisedToInteger: n) numberOfOneBits = 1 ]! !

!BitOpsTest methodsFor: 'multiple value tests' stamp: 'AndrewBlack 5/31/2012 11:27'!
testCountPowersOfTwoLessOne
	0 to: 30 do: [ :n | 
		self assert: ((2 raisedToInteger: n) - 1 ) numberOfOneBits = n ]
! !

!BitOpsTest methodsFor: 'multiple value tests' stamp: 'AndrewBlack 5/31/2012 11:30'!
testCountPowersOfTwoLessTwo
	1 to: 30 do: [ :n | 
		self assert: ((2 raisedToInteger: n) - 2) numberOfOneBits = (n - 1) ]! !

!BitOpsTest methodsFor: 'single pattern tests' stamp: 'AndrewBlack 5/31/2012 11:28'!
testCountSK3
	| sk3 |
	sk3 := 16r33333333.
	self assert: sk3 numberOfOneBits = 16! !

!BitOpsTest methodsFor: 'single pattern tests' stamp: 'AndrewBlack 5/31/2012 11:28'!
testCountSK5
	| sk5 |
	sk5 := 16r15555555.
	self assert: sk5 numberOfOneBits = 15! !

!BitOpsTest methodsFor: 'multiple value tests' stamp: 'AndrewBlack 5/31/2012 11:28'!
testCountThreeBits
	| p |
	p := #(2r0111 2r1011 2r1101 2r1110).
	0 to: 26 do: [ :n | 
		p do: [ :each | self assert: (each bitShift: n) numberOfOneBits = 3 ] ]! !

!BitOpsTest methodsFor: 'multiple value tests' stamp: 'AndrewBlack 5/31/2012 11:28'!
testCountTwoBits
	| p |
	p := #(2r0110 2r0101 2r0011 2r1100 2r1001 2r1010).
	0 to: 26 do: [ :n | 
		p do: [ :each | self assert: (each bitShift: n) numberOfOneBits = 2 ] ]! !
